//MyRect.cpp

#include <math.h>
#include "MyCircle.h"
#include "MyRect.h"

MyRect::MyRect( MyVector2& _min, MyVector2& _max  )
: min( _min ), max( _max )
{

}
//----------------------------------------------------------------------------------------------
MyRect::MyRect( float left, float bottom, float right, float top )
{
	fLeft = left;
	fBottom = bottom;
	fRight = right;
	fTop = top;
}
//----------------------------------------------------------------------------------------------
MyRect::~MyRect( )
{

}
//----------------------------------------------------------------------------------------------
bool MyRect::IncludePoint( float x, float y )
{
	if( x >= min.x && x <= max.y && y >= min.y && y <= max.y )
		return true;
	else
		return false;
}
//----------------------------------------------------------------------------------------------
bool MyRect::IncludeRect( MyRect& rect )
{
	if( min.x > rect.min.x )
		return false;
	if( max.x < rect.max.x )
		return false;
	if( min.y > rect.min.y )
		return false;
	if( max.y < rect.max.y )
		return false;
	return true;
}
//----------------------------------------------------------------------------------------------
bool MyRect::IntersectRect( MyRect& rect )
{
	if( min.x > rect.max.x ) 
		return false;
	if( max.x < rect.min.x ) 
		return false;
	if( min.y > rect.max.y ) 
		return false;
	if( max.y < rect.max.y ) 
		return false;
	return true;	
}
//----------------------------------------------------------------------------------------------
int MyRect::GetRectZone( float circleX, float circleY )
{
	int xZone = ( circleX <  min.x ) ? 0 :           
				( circleX >  max.x ) ? 2 : 1;
	int yZone = ( circleY <  min.y ) ? 0 :           
				( circleY >  max.y ) ? 2 : 1;
	int nZone = xZone + 3*yZone;
	return nZone;
}
//----------------------------------------------------------------------------------------------
//  6   7   8
//  3   4   5
//  0   1   2      4 Rect 
bool MyRect::IntersectCircle( MyCircle& circle )
{
	bool collisionDetected = false;
	int  nZone = GetRectZone( circle.x, circle.y );
	MyVector2 box = GetCenter();
	float halfHeight = GetHeight();
	float halfWidth = GetWidth();

	switch (nZone )
	{
	// top, bottom  ,  Ϳ Ÿ ˻Ѵ.
	case 1:
	case 7:
		{
			float distY = fabs( circle.y - box.y );
			if( distY <= ( circle.radius + halfHeight ) ) 
				collisionDetected = true;
		}
		break;
	// left, right  .  Ϳ Ÿ ˻Ѵ.
	case 3:
	case 5:
		{
			float distX = fabs( circle.x - box.x );
			if( distX <= ( circle.radius + halfWidth ) )
				collisionDetected = true;
		}
		break;
	// 簢  
    case 4:
		collisionDetected = true;
		break;
	// 𼭸 , 𼭸  ο ԵǴ ˻Ѵ.
	default:
		{
			float cornerX = ( nZone == 0 || nZone == 6 ) ? box.x - halfWidth : box.x + halfWidth;
			float cornerY = ( nZone == 0 || nZone == 2 ) ? box.y - halfHeight : box.y + halfHeight;
			if( circle.IncludePoint( cornerX, cornerY ) )	
				collisionDetected = true;
		}
		break;
	}

	return collisionDetected;
}
//----------------------------------------------------------------------------------------------
MyVector2 MyRect::GetCenter()
{
	MyVector2 center;
	center.x = min.x + ( max.x - min.x ) * 0.5f;
	center.y = min.y + ( max.y - min.y ) * 0.5f;
	return center;
}
//----------------------------------------------------------------------------------------------
float MyRect::GetWidth()
{
	return ( ( max.x - min.x ) * 0.5f );
}
//----------------------------------------------------------------------------------------------
float MyRect::GetHeight()
{
	return ( ( max.y - min.y ) * 0.5f );
}