//MyRect.h
#ifndef __MYRECT_H
#define __MYRECT_H

//     +------------------+  max
//     |                  |
//     |                  |
// min +------------------+

#include "MyVector2.h"

class MyRect
{
public:
	union
	{
		struct {
			MyVector2  min;
			MyVector2  max;
		};

		float fLeft, fBottom, fRight, fTop;
	};


public:
	MyRect( MyVector2& _min, MyVector2& _max );
	MyRect( float left, float bottom, float right, float top );
	~MyRect();
	
	MyVector2	GetCenter();
	float		GetWidth();
	float		GetHeight();
	
	//Collision method
	bool IncludePoint( float x, float y );
	bool IncludeRect( MyRect& rect );
	bool IntersectRect( MyRect& rect );
	//    http://hq.scene.ro/blog/read/circle-box-intersection-revised/
	bool IntersectCircle( MyCircle& circle );

protected:
	int	  GetRectZone( float circleX, float circleY );
};


#endif