//Flatten.cpp
#include "windows.h"
#include "../dx_util/MyMesh.h"
#include "TerrainChunk.h"
#include "Flatten.h"

Flatten::Flatten()
{

}
//------------------------------------------------------------------------
Flatten::~Flatten()
{

}
//------------------------------------------------------------------------
bool Flatten::Run( TerrainChunk* pChunk, float fx, float fy, float fOuterRadius, float fInnerRadius, float fStrength )
{
	int nFlattening = 2;
	float fInnerSq = fInnerRadius * fInnerRadius;
	//float fDistSq;

	MinMax2D bound = pChunk->DetermineMinMax2D( fx, fy, fOuterRadius );
	// if flattening is one, then nothing would be changed, so just skip the  process altogether.
	if( nFlattening > 1 )
	{
		for( int row = bound.yMin; row <= bound.yMax; ++row )
		{
			for( int col = bound.xMin; col <= bound.xMax; ++col )
			{
				float fFlat 	= fStrength;
				//߽  Ÿ
				//FIX
#if  0
				//߽  Ÿ
				float distX = fx - pChunk->GetX( col );    
				float distY = fy - pChunk->GetY( row );
				fDistSq = distX * distX + distY * distY;
				if( fDistSq <= fInnerSq)
					continue;
#endif
				MyVector3 curVec = pChunk->GetVertex( col, row );
				float fOriginal	= curVec.z;
				
				// flatten as many times as desired
				for( int i = 0; i < nFlattening; ++i )
				{
					fFlat *= fOriginal;
				}
				
				// put it back into the cell
				pChunk->SetHeight( col, row, fFlat );
			}
		}
	}

	return true;
}