//Raise.cpp
#include "windows.h"
#include "../dx_util/MyMesh.h"
#include "TerrainChunk.h"
#include "Raise.h"


Raise::Raise()
{

}
//---------------------------------------------------------------------------------
Raise::~Raise()
{

}
//---------------------------------------------------------------------------------
bool Raise::Run( TerrainChunk* pChunk, float fx, float fy, float fOuterRadius, float fInnerRadius, float fStrength )
{
	float fInnerSq = fInnerRadius * fInnerRadius;
	float fRadiusSq = fOuterRadius * fOuterRadius;	
	float fDistSq;
	float fHeight;
	MinMax2D bound = pChunk->DetermineMinMax2D( fx, fy, fOuterRadius );


	// for each affected cell, determine the height of the hill at that point
	// and add it to that cell
	for( int row = bound.yMin; row <= bound.yMax; ++row )
	{
		for( int col = bound.xMin; col <= bound.xMax; ++col )
		{
			//߽  Ÿ
			float distX = fx - pChunk->GetX( col );    
			float distY = fy - pChunk->GetY( row );
			fDistSq = distX * distX + distY * distY;
			//Ÿκ  ̸ Ѵ.
			fHeight = fRadiusSq - fDistSq;

			if( fDistSq <= fInnerSq)
				fHeight = fRadiusSq - fInnerSq;
			fHeight *= fStrength;
			
			//̰ ̳ʽ ߰ ʴ´.(i.e. outside the hill's radius)
			if( fHeight > 0 )
			{
				MyVector3 curVec = pChunk->GetVertex( col, row);
				pChunk->SetHeight( col, row, curVec.z + fHeight );
			}	
		}
	}

	return true;
}
