//TerrainChunk.h
#ifndef __TERRAINCHUNK_H
#define __TERRAINCHUNK_H

#include "TerrainCommand.h"

class MyMesh;

class TerrainChunk
{
	MyMesh* m_pMesh;

public:
	TerrainChunk();
	~TerrainChunk();

	bool Create( float* pfHeight = 0L );
	void Release();
	MyMesh* GetMyMesh();

	void	ComputeNormal( float fx, float fy, float fRadius );

	float	GetCol( float fx );
	float	GetRow( float fy );
	float	GetX( int col );	
	float	GetY( int col );
	MinMax2D    DetermineMinMax2D(  float fx, float fy, float fRadius );

	float	GetHeight( float fx, float fy );
	MyVector3&  GetVertex( int col, int row );
	void		SetHeight( int col, int row, float fHeight );
	const MyVector3&  GetNormal( float fx, float fy );
	
protected:
	MyMesh*	Make();
	MyMesh* Make( float* pfHeight );

	void		SetNormal( int col, int row, MyVector3* pVector );
	MyVector3	CalcOneNormal( int col, int row );
	MyVector3   CalcTwoNormal( int col, int row );
	MyVector3	CalcSmoothNormal( int col, int row );
};


#endif