//util.cppp
#include "util.h"
#include <windows.h>
#include <math.h>
#include "dx_util/MyMesh.h"
#include "terrain/TerrainChunk.h"

class TerrainChunk;

//Right Handed, Z-UP ǥ̴.
//http://www.cprogramming.com/tutorial/3d/rotation.html Ұ
void RH_RotationMatrix(D3DXMATRIX& out, MyVector3 axis, float angle)
{
	axis.Normalize();

    float s = sin(angle);
    float c = cos(angle);
    float t = 1.0f - c;

	float x = axis.x; float x2 = x*x;
	float y = axis.y; float y2 = y*y;
	float z = axis.z; float z2 = z*z;

	D3DXMATRIX& mat = out;
	D3DXMatrixIdentity(&mat);
	mat._11 = t*x2 + c; mat._12 = t*x*y + s*z; mat._13 = t*x*z - s*y;
	mat._21 = t*x*y - s*y; mat._22 = t*y2 + c; mat._23 = t*y*z + s*x;
	mat._31 = t*x*z + s*y; mat._32 = t*y*z - s*x; mat._33 = t*z2 + c;    
}

// ǥ踦 ϴ,  ޼ ķ D3DTS_WORLD  ؾ Ѵ.
void LH_RotationMatrix(D3DXMATRIX& out, MyVector3 axis, float angle)
{
	axis.Normalize();

    float s = sin(angle);
    float c = cos(angle);
    float t = 1.0f - c;

	float x = axis.x; float x2 = x*x;
	float y = axis.y; float y2 = y*y;
	float z = axis.z; float z2 = z*z;

	D3DXMATRIX& mat = out;
	D3DXMatrixIdentity(&mat);
	mat._11 = t*x2 + c; mat._12 = t*x*y - s*z; mat._13 = t*x*z + s*y;
	mat._21 = t*x*y + s*y; mat._22 = t*y2 + c; mat._23 = t*y*z - s*x;
	mat._31 = t*x*z - s*y; mat._32 = t*y*z + s*x; mat._33 = t*z2 + c;    
}


void GetTerrainSlope(D3DXMATRIX& out, TerrainChunk* pChunk, float x, float y, float z )
{
	//1.    ϱ
	const MyVector3& vec = pChunk->GetNormal( x, y );
	
	//2.   Ϳ Up   ȸ  ϱ
	MyVector3 rAxis, up = MyVector3(0, 0, 1);
	rAxis.Cross(vec, up);

	//3.   Ϳ Up    ȸ ϱ
	float dot = vec*up; 

	//4. ȸ ȸ ȯ
	float angle = acos(dot);

	//5. ȸ ȸ ŭ  ϱ
	LH_RotationMatrix(out, rAxis, angle);
}